## org.apache.poi.hwpf.model.types
Class FibBaseAbstractType

    java.lang.Object
      org.apache.poi.hwpf.model.types.FibBaseAbstractType

Direct Known Subclasses:
  FibBase

    @Internal
    public abstract class FibBaseAbstractType

extends java.lang.Object

Base part of the File information Block (FibBase). Holds the core part of the FIB, from the first 32 bytes.

Class and fields descriptions are quoted from Microsoft Office Word 97-2007 Binary File Format and [MS-DOC] - v20110608 Word (.doc) Binary File Format

NOTE: This source is automatically generated please do not modify this file. Either subclass or remove the record in src/types/definitions.

This class is internal. It content or properties may change without notice due to changes in our knowledge of internal Microsoft Word binary structures.

Author:
  Andrew C. Oliver; Sergey Vladimirov; according to Microsoft Office Word 97-2007 Binary File Format Specification [*.doc] and [MS-DOC] - v20110608 Word (.doc) Binary File Format

Field Summary
`protected int` `field_1_wIdent`
`protected byte` `field_10_flags2`
`protected short` `field_11_Chs` Deprecated.
`protected short` `field_12_chsTables` Deprecated.
`protected int` `field_13_fcMin` Deprecated.
`protected int` `field_14_fcMac` Deprecated.
`protected int` `field_2_nFib`
`protected int` `field_3_unused`
`protected int` `field_4_lid`
`protected int` `field_5_pnNext`
`protected short` `field_6_flags1`
`protected int` `field_7_nFibBack`
`protected int` `field_8_lKey`
`protected byte` `field_9_envr` Deprecated.

Constructor Summary
`protected` `FibBaseAbstractType()`

Method Summary
`protected void` `fillFields(byte[] data, int offset)`
`short` `getChs()` This value MUST be 0 and MUST be ignored.
`short` `getChsTables()` This value MUST be 0 and MUST be ignored.
`byte` `getCQuickSaves()` An unsigned integer.
`byte` `getEnvr()` This value MUST be 0, and MUST be ignored.
`int` `getFcMac()` This value is undefined and MUST be ignored.
`int` `getFcMin()` This value is undefined and MUST be ignored.
`short` `getFlags1()` Get the flags1 field for the FibBase record.
`byte` `getFlags2()` Get the flags2 field for the FibBase record.
`byte` `getFSpare0()` Deprecated. This field should not be used according to specification
`int` `getLid()` A LID that specifies the install language of the application that is producing the document.
`int` `getLKey()` If fEncryption is 1 and fObfuscation is 1, this value specifies the XOR obfuscation password verifier.
`int` `getNFib()` An unsigned integer that specifies the version number of the file format used.
`int` `getNFibBack()` This value SHOULD be 0x00BF.
`int` `getPnNext()` An unsigned integer that specifies the offset in the WordDocument stream of the FIB for the document which contains all the AutoText items.
`static int` `getSize()` Size of record
`int` `getUnused()` This value is undefined and MUST be ignored.
`int` `getWIdent()` An unsigned integer that specifies that this is a Word Binary File.
`boolean` `isFComplex()` Specifies that the last save operation that was performed on this document was an incremental save operation
`boolean` `isFDot()` Specifies whether this is a document template
`boolean` `isFEmptySpecial()` Deprecated. This field should not be used according to specification
`boolean` `isFEncrypted()` Specifies whether the document is encrypted or obfuscated as specified in Encryption and Obfuscation
`boolean` `isFExtChar()` This value MUST be 1
`boolean` `isFFarEast()` Specifies whether the installation language of the application that created the document was an East Asian language
`boolean` `isFGlsy()` Specifies whether this is a document that contains only AutoText items
`boolean` `isFHasPic()` When set to 0, there SHOULD be no pictures in the document
`boolean` `isFLoadOverride()` Specifies whether to override the language information and font that are specified in the paragraph style at istd 0 (the normal style) with the defaults that are appropriate for the installation language of the application
`boolean` `isFLoadOverridePage()` Specifies whether to override the section properties for page size, orientation, and margins with the defaults that are appropriate for the installation language of the application
`boolean` `isFMac()` Deprecated. This field should not be used according to specification
`boolean` `isFObfuscated()` If fEncrypted is 1, this bit specifies whether the document is obfuscated by using XOR obfuscation; otherwise, this bit MUST be ignored
`boolean` `isFReadOnlyRecommended()` Specifies whether the document author recommended that the document be opened in read-only mode
`boolean` `isFWhichTblStm()` Specifies the Table stream to which the FIB refers.
`boolean` `isFWriteReservation()` Specifies whether the document has a write-reservation password
`boolean` `isReserved1()` Deprecated. This field should not be used according to specification
`boolean` `isReserved2()` Deprecated. This field should not be used according to specification
`byte[]` `serialize()`
`void` `serialize(byte[] data, int offset)`
`void` `setChs(short field_11_Chs)` This value MUST be 0 and MUST be ignored.
`void` `setChsTables(short field_12_chsTables)` This value MUST be 0 and MUST be ignored.
`void` `setCQuickSaves(byte value)` Sets the cQuickSaves field value.
`void` `setEnvr(byte field_9_envr)` This value MUST be 0, and MUST be ignored.
`void` `setFcMac(int field_14_fcMac)` This value is undefined and MUST be ignored.
`void` `setFcMin(int field_13_fcMin)` This value is undefined and MUST be ignored.
`void` `setFComplex(boolean value)` Sets the fComplex field value.
`void` `setFDot(boolean value)` Sets the fDot field value.
`void` `setFEmptySpecial(boolean value)` Sets the fEmptySpecial field value.
`void` `setFEncrypted(boolean value)` Sets the fEncrypted field value.
`void` `setFExtChar(boolean value)` Sets the fExtChar field value.
`void` `setFFarEast(boolean value)` Sets the fFarEast field value.
`void` `setFGlsy(boolean value)` Sets the fGlsy field value.
`void` `setFHasPic(boolean value)` Sets the fHasPic field value.
`void` `setFlags1(short field_6_flags1)` Set the flags1 field for the FibBase record.
`void` `setFlags2(byte field_10_flags2)` Set the flags2 field for the FibBase record.
`void` `setFLoadOverride(boolean value)` Sets the fLoadOverride field value.
`void` `setFLoadOverridePage(boolean value)` Sets the fLoadOverridePage field value.
`void` `setFMac(boolean value)` Sets the fMac field value.
`void` `setFObfuscated(boolean value)` Sets the fObfuscated field value.
`void` `setFReadOnlyRecommended(boolean value)` Sets the fReadOnlyRecommended field value.
`void` `setFSpare0(byte value)` Sets the fSpare0 field value.
`void` `setFWhichTblStm(boolean value)` Sets the fWhichTblStm field value.
`void` `setFWriteReservation(boolean value)` Sets the fWriteReservation field value.
`void` `setLid(int field_4_lid)` A LID that specifies the install language of the application that is producing the document.
`void` `setLKey(int field_8_lKey)` If fEncryption is 1 and fObfuscation is 1, this value specifies the XOR obfuscation password verifier.
`void` `setNFib(int field_2_nFib)` An unsigned integer that specifies the version number of the file format used.
`void` `setNFibBack(int field_7_nFibBack)` This value SHOULD be 0x00BF.
`void` `setPnNext(int field_5_pnNext)` An unsigned integer that specifies the offset in the WordDocument stream of the FIB for the document which contains all the AutoText items.
`void` `setReserved1(boolean value)` Sets the reserved1 field value.
`void` `setReserved2(boolean value)` Sets the reserved2 field value.
`void` `setUnused(int field_3_unused)` This value is undefined and MUST be ignored.
`void` `setWIdent(int field_1_wIdent)` An unsigned integer that specifies that this is a Word Binary File.
`java.lang.String` `toString()`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### field_1_wIdent

    protected int field_1_wIdent

### field_2_nFib

    protected int field_2_nFib

### field_3_unused

    protected int field_3_unused

### field_4_lid

    protected int field_4_lid

### field_5_pnNext

    protected int field_5_pnNext

### field_6_flags1

    protected short field_6_flags1

### field_7_nFibBack

    protected int field_7_nFibBack

### field_8_lKey

    protected int field_8_lKey

### field_9_envr

    @Deprecated
    protected byte field_9_envr

  Deprecated.

### field_10_flags2

    protected byte field_10_flags2

### field_11_Chs

    @Deprecated
    protected short field_11_Chs

  Deprecated.

### field_12_chsTables

    @Deprecated
    protected short field_12_chsTables

  Deprecated.

### field_13_fcMin

    @Deprecated
    protected int field_13_fcMin

  Deprecated.

### field_14_fcMac

    @Deprecated
    protected int field_14_fcMac

  Deprecated.

Constructor Detail

### FibBaseAbstractType

    protected FibBaseAbstractType()

Method Detail

### fillFields

    protected void fillFields(byte[] data,
                              int offset)

### serialize

    public void serialize(byte[] data,
                          int offset)

### serialize

    public byte[] serialize()

### getSize

    public static int getSize()

  Size of record

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `java.lang.Object`

### getWIdent

    @Internal
    public int getWIdent()

  An unsigned integer that specifies that this is a Word Binary File. This value MUST be 0xA5EC.

### setWIdent

    @Internal
    public void setWIdent(int field_1_wIdent)

  An unsigned integer that specifies that this is a Word Binary File. This value MUST be 0xA5EC.

### getNFib

    @Internal
    public int getNFib()

  An unsigned integer that specifies the version number of the file format used. Superseded by FibRgCswNew.nFibNew if it is present. This value SHOULD be 0x00C1.

### setNFib

    @Internal
    public void setNFib(int field_2_nFib)

  An unsigned integer that specifies the version number of the file format used. Superseded by FibRgCswNew.nFibNew if it is present. This value SHOULD be 0x00C1.

### getUnused

    @Internal
    public int getUnused()

  This value is undefined and MUST be ignored.

### setUnused

    @Internal
    public void setUnused(int field_3_unused)

  This value is undefined and MUST be ignored.

### getLid

    @Internal
    public int getLid()

  A LID that specifies the install language of the application that is producing the document. If nFib is 0x00D9 or greater, then any East Asian install lid or any install lid with a base language of Spanish, German or French MUST be recorded as lidAmerican. If the nFib is 0x0101 or greater, then any install lid with a base language of Vietnamese, Thai, or Hindi MUST be recorded as lidAmerican..

### setLid

    @Internal
    public void setLid(int field_4_lid)

  A LID that specifies the install language of the application that is producing the document. If nFib is 0x00D9 or greater, then any East Asian install lid or any install lid with a base language of Spanish, German or French MUST be recorded as lidAmerican. If the nFib is 0x0101 or greater, then any install lid with a base language of Vietnamese, Thai, or Hindi MUST be recorded as lidAmerican..

### getPnNext

    @Internal
    public int getPnNext()

  An unsigned integer that specifies the offset in the WordDocument stream of the FIB for the document which contains all the AutoText items.

### setPnNext

    @Internal
    public void setPnNext(int field_5_pnNext)

  An unsigned integer that specifies the offset in the WordDocument stream of the FIB for the document which contains all the AutoText items.

### getFlags1

    @Internal
    public short getFlags1()

  Get the flags1 field for the FibBase record.

### setFlags1

    @Internal
    public void setFlags1(short field_6_flags1)

  Set the flags1 field for the FibBase record.

### getNFibBack

    @Internal
    public int getNFibBack()

  This value SHOULD be 0x00BF. This value MUST be 0x00BF or 0x00C1.

### setNFibBack

    @Internal
    public void setNFibBack(int field_7_nFibBack)

  This value SHOULD be 0x00BF. This value MUST be 0x00BF or 0x00C1.

### getLKey

    @Internal
    public int getLKey()

  If fEncryption is 1 and fObfuscation is 1, this value specifies the XOR obfuscation password verifier. If fEncryption is 1 and fObfuscation is 0, this value specifies the size of the EncryptionHeader that is stored at the beginning of the Table stream as described in Encryption and Obfuscation. Otherwise, this value MUST be 0.

### setLKey

    @Internal
    public void setLKey(int field_8_lKey)

  If fEncryption is 1 and fObfuscation is 1, this value specifies the XOR obfuscation password verifier. If fEncryption is 1 and fObfuscation is 0, this value specifies the size of the EncryptionHeader that is stored at the beginning of the Table stream as described in Encryption and Obfuscation. Otherwise, this value MUST be 0.

### getEnvr

    @Internal
    public byte getEnvr()

  This value MUST be 0, and MUST be ignored.

### setEnvr

    @Internal
    public void setEnvr(byte field_9_envr)

  This value MUST be 0, and MUST be ignored.

### getFlags2

    @Internal
    public byte getFlags2()

  Get the flags2 field for the FibBase record.

### setFlags2

    @Internal
    public void setFlags2(byte field_10_flags2)

  Set the flags2 field for the FibBase record.

### getChs

    @Internal
    public short getChs()

  This value MUST be 0 and MUST be ignored.

### setChs

    @Internal
    public void setChs(short field_11_Chs)

  This value MUST be 0 and MUST be ignored.

### getChsTables

    @Internal
    public short getChsTables()

  This value MUST be 0 and MUST be ignored.

### setChsTables

    @Internal
    public void setChsTables(short field_12_chsTables)

  This value MUST be 0 and MUST be ignored.

### getFcMin

    @Internal
    public int getFcMin()

  This value is undefined and MUST be ignored.

### setFcMin

    @Internal
    public void setFcMin(int field_13_fcMin)

  This value is undefined and MUST be ignored.

### getFcMac

    @Internal
    public int getFcMac()

  This value is undefined and MUST be ignored.

### setFcMac

    @Internal
    public void setFcMac(int field_14_fcMac)

  This value is undefined and MUST be ignored.

### setFDot

    @Internal
    public void setFDot(boolean value)

  Sets the fDot field value. Specifies whether this is a document template

### isFDot

    @Internal
    public boolean isFDot()

  Specifies whether this is a document template

  Returns:
    the fDot field value.

### setFGlsy

    @Internal
    public void setFGlsy(boolean value)

  Sets the fGlsy field value. Specifies whether this is a document that contains only AutoText items

### isFGlsy

    @Internal
    public boolean isFGlsy()

  Specifies whether this is a document that contains only AutoText items

  Returns:
    the fGlsy field value.

### setFComplex

    @Internal
    public void setFComplex(boolean value)

  Sets the fComplex field value. Specifies that the last save operation that was performed on this document was an incremental save operation

### isFComplex

    @Internal
    public boolean isFComplex()

  Specifies that the last save operation that was performed on this document was an incremental save operation

  Returns:
    the fComplex field value.

### setFHasPic

    @Internal
    public void setFHasPic(boolean value)

  Sets the fHasPic field value. When set to 0, there SHOULD be no pictures in the document

### isFHasPic

    @Internal
    public boolean isFHasPic()

  When set to 0, there SHOULD be no pictures in the document

  Returns:
    the fHasPic field value.

### setCQuickSaves

    @Internal
    public void setCQuickSaves(byte value)

  Sets the cQuickSaves field value. An unsigned integer. If nFib is less than 0x00D9, then cQuickSaves specifies the number of consecutive times this document was incrementally saved. If nFib is 0x00D9 or greater, then cQuickSaves MUST be 0xF

### getCQuickSaves

    @Internal
    public byte getCQuickSaves()

  An unsigned integer. If nFib is less than 0x00D9, then cQuickSaves specifies the number of consecutive times this document was incrementally saved. If nFib is 0x00D9 or greater, then cQuickSaves MUST be 0xF

  Returns:
    the cQuickSaves field value.

### setFEncrypted

    @Internal
    public void setFEncrypted(boolean value)

  Sets the fEncrypted field value. Specifies whether the document is encrypted or obfuscated as specified in Encryption and Obfuscation

### isFEncrypted

    @Internal
    public boolean isFEncrypted()

  Specifies whether the document is encrypted or obfuscated as specified in Encryption and Obfuscation

  Returns:
    the fEncrypted field value.

### setFWhichTblStm

    @Internal
    public void setFWhichTblStm(boolean value)

  Sets the fWhichTblStm field value. Specifies the Table stream to which the FIB refers. When this value is set to 1, use 1Table; when this value is set to 0, use 0Table.

### isFWhichTblStm

    @Internal
    public boolean isFWhichTblStm()

  Specifies the Table stream to which the FIB refers. When this value is set to 1, use 1Table; when this value is set to 0, use 0Table.

  Returns:
    the fWhichTblStm field value.

### setFReadOnlyRecommended

    @Internal
    public void setFReadOnlyRecommended(boolean value)

  Sets the fReadOnlyRecommended field value. Specifies whether the document author recommended that the document be opened in read-only mode

### isFReadOnlyRecommended

    @Internal
    public boolean isFReadOnlyRecommended()

  Specifies whether the document author recommended that the document be opened in read-only mode

  Returns:
    the fReadOnlyRecommended field value.

### setFWriteReservation

    @Internal
    public void setFWriteReservation(boolean value)

  Sets the fWriteReservation field value. Specifies whether the document has a write-reservation password

### isFWriteReservation

    @Internal
    public boolean isFWriteReservation()

  Specifies whether the document has a write-reservation password

  Returns:
    the fWriteReservation field value.

### setFExtChar

    @Internal
    public void setFExtChar(boolean value)

  Sets the fExtChar field value. This value MUST be 1

### isFExtChar

    @Internal
    public boolean isFExtChar()

  This value MUST be 1

  Returns:
    the fExtChar field value.

### setFLoadOverride

    @Internal
    public void setFLoadOverride(boolean value)

  Sets the fLoadOverride field value. Specifies whether to override the language information and font that are specified in the paragraph style at istd 0 (the normal style) with the defaults that are appropriate for the installation language of the application

### isFLoadOverride

    @Internal
    public boolean isFLoadOverride()

  Specifies whether to override the language information and font that are specified in the paragraph style at istd 0 (the normal style) with the defaults that are appropriate for the installation language of the application

  Returns:
    the fLoadOverride field value.

### setFFarEast

    @Internal
    public void setFFarEast(boolean value)

  Sets the fFarEast field value. Specifies whether the installation language of the application that created the document was an East Asian language

### isFFarEast

    @Internal
    public boolean isFFarEast()

  Specifies whether the installation language of the application that created the document was an East Asian language

  Returns:
    the fFarEast field value.

### setFObfuscated

    @Internal
    public void setFObfuscated(boolean value)

  Sets the fObfuscated field value. If fEncrypted is 1, this bit specifies whether the document is obfuscated by using XOR obfuscation; otherwise, this bit MUST be ignored

### isFObfuscated

    @Internal
    public boolean isFObfuscated()

  If fEncrypted is 1, this bit specifies whether the document is obfuscated by using XOR obfuscation; otherwise, this bit MUST be ignored

  Returns:
    the fObfuscated field value.

### setFMac

    @Internal
    public void setFMac(boolean value)

  Sets the fMac field value. This value MUST be 0, and MUST be ignored

### isFMac

    @Internal
    @Deprecated
    public boolean isFMac()

  Deprecated. This field should not be used according to specification

  This value MUST be 0, and MUST be ignored

  Returns:
    the fMac field value.

### setFEmptySpecial

    @Internal
    public void setFEmptySpecial(boolean value)

  Sets the fEmptySpecial field value. This value SHOULD be 0 and SHOULD be ignored

### isFEmptySpecial

    @Internal
    @Deprecated
    public boolean isFEmptySpecial()

  Deprecated. This field should not be used according to specification

  This value SHOULD be 0 and SHOULD be ignored

  Returns:
    the fEmptySpecial field value.

### setFLoadOverridePage

    @Internal
    public void setFLoadOverridePage(boolean value)

  Sets the fLoadOverridePage field value. Specifies whether to override the section properties for page size, orientation, and margins with the defaults that are appropriate for the installation language of the application

### isFLoadOverridePage

    @Internal
    public boolean isFLoadOverridePage()

  Specifies whether to override the section properties for page size, orientation, and margins with the defaults that are appropriate for the installation language of the application

  Returns:
    the fLoadOverridePage field value.

### setReserved1

    @Internal
    public void setReserved1(boolean value)

  Sets the reserved1 field value. This value is undefined and MUST be ignored

### isReserved1

    @Internal
    @Deprecated
    public boolean isReserved1()

  Deprecated. This field should not be used according to specification

  This value is undefined and MUST be ignored

  Returns:
    the reserved1 field value.

### setReserved2

    @Internal
    public void setReserved2(boolean value)

  Sets the reserved2 field value. This value is undefined and MUST be ignored

### isReserved2

    @Internal
    @Deprecated
    public boolean isReserved2()

  Deprecated. This field should not be used according to specification

  This value is undefined and MUST be ignored

  Returns:
    the reserved2 field value.

### setFSpare0

    @Internal
    public void setFSpare0(byte value)

  Sets the fSpare0 field value. This value is undefined and MUST be ignored

### getFSpare0

    @Internal
    @Deprecated
    public byte getFSpare0()

  Deprecated. This field should not be used according to specification

  This value is undefined and MUST be ignored

  Returns:
    the fSpare0 field value.

Copyright 2012 The Apache Software Foundation or its licensors, as applicable.